/* Copyright 1993, Florida State University (FSU)

 * This software is distributed "as-is", without any warranty,
 * expressed or implied, including, but not limited to, the
 * warranties of merchantability or fitness for a particular purpose. 

 * The entire risk as to the quality and performance of the
 * software is with you.  Should the software prove defective, you assume
 * the cost of all necessary servicing, repair or correction.

 * FSU and the authors shall not be liable to you for damages,
 * including any general, special, incidental or consequential damages
 * arising out of the use or inability to use the software (including
 * but not limited to loss of data or data being rendered inaccurate or
 * losses sustained by you or third parties or a failure of the
 * software to operate with any other software).

 * General permission to copy and distribute this code and to
 * execute it within a computer, without fee, is granted provided
 * that this is not done for commercial advantage, and that this
 * notice is included.  All other rights are reserved.
 */

/*
 * $Id: get_c_constants.c,v 1.5 1993/05/19 18:32:15 mueller Exp $
 * $Log: get_c_constants.c,v $
 * Revision 1.5  1993/05/19  18:32:15  mueller
 * PART release with CARTS interface
 *
 */

#define ADA_MIN_PRIO 0
#define ADA_MAX_PRIO 99
#define ADD_PRIO 2 /* additional prio levels for int. entries, mutex ceiling */

#define _POSIX_THREAD_PRIORITY_SCHEDULING   /* Who knows why we need this? */
#define _POSIX_THREAD_PRIO_CEILING   /* Who knows why we need this? */
#define PTHREAD_KERNEL
#include "/alpha/threads/src/pthread.h"
#include "/alpha/threads/src/setjmp.h"

main()
{
  pthread_t p = NULL;
  
  printf("-- Copyright 1993, Florida State University (FSU)\n");
  printf("\n");
  printf("-- This software is distributed \"as-is\", without any warranty,\n");
  printf("-- expressed or implied, including, but not limited to, the\n");
  printf("-- warranties of merchantability or fitness for a particular purpose.\n");
  printf("\n");
  printf("-- The entire risk as to the quality and performance of the\n");
  printf("-- software is with you.  Should the software prove defective, you assume\n");
  printf("-- the cost of all necessary servicing, repair or correction. \n");
  printf("\n");
  printf("-- FSU and the authors shall not be liable to you for damages,\n");
  printf("-- including any general, special, incidental or consequential damages\n");
  printf("-- arising out of the use or inability to use the software (including\n");
  printf("-- but not limited to loss of data or data being rendered inaccurate or\n");
  printf("-- losses sustained by you or third parties or a failure of the\n");
  printf("-- software to operate with any other software).\n");
  printf("\n");
  printf("-- General permission to copy and distribute this code and to\n");
  printf("-- execute it within a computer, without fee, is granted provided\n");
  printf("-- that this is not done for commercial advantage, and that this\n");
  printf("-- notice is included.  All other rights are reserved.\n");
  printf("\n");
  
  printf("package C_Constants is\n\n");
  printf("pthread_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_t));
  printf("pthread_attr_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_attr_t));
  printf("pthread_mutexattr_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_mutexattr_t));
  printf("pthread_mutex_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_mutex_t));
  printf("pthread_condattr_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_condattr_t));
  printf("pthread_cond_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_cond_t));
  printf("pthread_key_t_size : constant Integer := %d;\n", 
	 sizeof(pthread_key_t));
  /*
  printf("PTHREAD_PROCASYNC : constant Integer := %d;\n",
         PTHREAD_PROCASYNC);
  printf("PTHREAD_PROCSYNC : constant Integer := %d;\n",
         PTHREAD_PROCSYNC);
  */    
  
  printf("pthread_jmp_buf_size : constant Integer := %d;\n",
	 sizeof(struct jmp_buf));
  printf("pthread_sigjmp_buf_size : constant Integer := %d;\n",
	 sizeof(struct sigjmp_buf));
  
  if (sched_get_priority_min(SCHED_FIFO) > ADA_MIN_PRIO ||
      sched_get_priority_max(SCHED_FIFO) < ADA_MAX_PRIO + ADD_PRIO)
    fprintf(stderr, "ERROR: Pthreads priority range too small\n");
  else
    printf("Add_Prio : constant Integer := %d;\n", ADD_PRIO);
  printf("\nend C_Constants;\n");
  return(0);
}
